#include "VKString.h"
#include "Sortable.h"
#include "FileManagement.h"

#include "ShapeTriangleSoup.h"

#include "Interactor.h"


class BindingManager;
class AnalysisWriter;



#ifndef __AnalysisWriter_H
#define __AnalysisWriter_H

class AnalysisWriter
{
	public:
		AnalysisWriter();
		virtual void Write() const;
		
		virtual void AddWriteMap(const VKString & data, const VKString & file);
		virtual void SetBindingManager(const BindingManager * binding);
		virtual void SetInteractor(Interactor::InteractorID id, const Interactor * interactor);
		virtual const VKString & GetWriteMap(const VKString & data) const;
	
		virtual VKString GetEnergyStr(int poseid = -1, bool detailed = false) const;
	
	
	protected:
		std::map<VKString, VKString> m_WriteMap;
		
		const BindingManager * m_pBinding;
		const Interactor * m_Interactors[2];
};



#endif



