#include "VKString.h"
#include "Sortable.h"
#include "FileManagement.h"

#include "RendererGLUT.h"
#include "DatabaseVisWindow.h"
#include "ShapeTriangleSoup.h"

#include "Interactor.h"


class BindingManager;
class AnalysisWriter;



#ifndef __VisInteractor_H
#define __VisInteractor_H

class VisInteractor
{
	public:
		VisInteractor(const Interactor * interactor);		
		virtual void FillRenderableArray(const InteractorPose * pose, const R3Affine & xform, const R3Affine & cam,
										 std::vector<RenderableFace> & faces) const;
#ifdef INCLUDE_BULLET
		virtual void FillPhysicsRenderableArray(const InteractorPose * pose, const R3Affine & xform,
												std::vector<RenderableFace> & faces) const;
		virtual void FillShapeRenderableArray(const btCollisionShape * shape, const R3Affine & xform,
											  std::vector<RenderableFace> & faces) const;
#endif
		virtual void FillUnitSphere(std::vector<RenderableFace> & faces, int size) const;
		virtual void FillCylinderForRendering(double r, double h, int axis, int nvertices, std::vector<RenderableFace> & face) const;

//	protected:
		const Interactor * m_pInteractor;
};



#endif



