#include "VKString.h"
#include "Sortable.h"
#include "FileManagement.h"

#include "RendererGLUT.h"
#include "DatabaseVisWindow.h"
#include "ModelDatabase.h"
#include "ShapeTriangleSoup.h"
#include "DBApp.h"

#include "Classifier.h"

#ifndef __VisClassifierApp_H
#define __VisClassifierApp_H


class VisClassifierApp : public DBApp
{
	public:
		VisClassifierApp(Classifier * cla);
		virtual bool KeyPressed(DatabaseVisWindow * window, const char key, int mouseX, int mouseY);
		virtual bool Draw(DatabaseVisWindow * window);
		virtual void SetScreenshotType(const VKString & sName, int value);
		virtual bool DrawCombined(DatabaseVisWindow * window, double threshold);
	
		static std::vector<double> s_Thresholds;
		
	protected:
		Classifier * m_pCla;
		double m_fScaleEverything;
		
		double m_fReferenceDistance;
		double m_fValueThreshold;
		
		VKString m_sShotType;
		int m_iShotValue;

		int m_iTrainedLabel;
};

#endif



