#include "Clustering.h"
#include "gaps.h"

#ifndef __CLUSTER_PRIORS_H
#define __CLUSTER_PRIORS_H

class ClusterGridParams
{
	public:
		ClusterGridParams();
		double m_fValCap;
};

/**
 * This algorithm does not cluster -- only extracts modes
 */
class ClusterGrid : public ClusteringAlgorithm
{
	public:
	/** NOTE: ndims<=3 */
		ClusterGrid(int ndims, double * cellSize, double * domainMin, double * domainMax);
		virtual void Cluster(ClusteringProblem & problem);
		virtual ClusterGridParams & Params();

	protected:
		virtual int GetBin(double val, double minval, double maxval, int ncells);

	// problem setup constants
		int m_iNDims;
		int * m_aNBins;
		double * m_afCellSize;
		double * m_afDomainMin;
		double * m_afDomainMax;
		double * m_1DGrid;
		R3Grid * m_pR3Grid;
	
	// parameters
		ClusterGridParams m_Params;
};

#endif

