#include "VKString.h"
#include "Sortable.h"
#include "FileManagement.h"

#include "RendererGLUT.h"
#include "DatabaseVisWindow.h"
#include "ModelDatabase.h"
#include "ShapeTriangleSoup.h"

#include "DBApp.h"

#ifndef __MetricVisApp_H
#define __MetricVisApp_H


class MetricVisApp : public DBApp
{
	public:
		enum VisMetric
		{
			VISMETRIC_None = 0,
			VISMETRIC_Mesh	     	 = 1<<0,
			VISMETRIC_Pnts	     	 = 1<<1,
			VISMETRIC_NhdHighlight 	 = 1<<2,
			VISMETRIC_NhdSphere 	 = 1<<3,
			VISMETRIC_NhdWireframe 	 = 1<<4,
			VISMETRIC_NhdGraph	     = 1<<5
			
		};
		MetricVisApp(Model3D * model, ShapeMesh * mesh, ShapePointCloud * pnts, ShapeDistance * dist);
		
		virtual bool KeyPressed(DatabaseVisWindow * window, const char key, int mouseX, int mouseY);
		virtual bool Draw(DatabaseVisWindow * window);
		
	protected:
		Model3D * m_pModel;
		ShapeMesh * m_pMesh;
		ShapePointCloud * m_pPnts;
		ShapeDistance * m_pDistance;
	
		double m_fNhdRadius;		// neighborhood radius
		int m_iSelectedPnt;
};


#endif




