function findAndWriteEigenvectorsSparse(prefix, numeigv, m_check, n_check)
try 
    tic;
    A = loadMatrixSparse([prefix '.matrix.bin']);
    [m n] = size(A);
    
    fprintf('Non-zero: %d, NumEig: %d\n',nnz(A), numeigv);
    
    if exist('m_check')
        assert(m_check==m);
    end
    
    if exist('n_check')
        assert(n_check==n)
    end
    
    OPTS.maxit = 300;
    [V E] = eigs(A, numeigv, 'LM', OPTS);
    [Vm Vn] = size(V);
    fprintf('Writing Dense Matrix %d x %d\n', Vm, Vn);
    
    %assert(norm(imag(E))==0);
    %assert(norm(imag(V))==0);
    if norm(imag(E))>0
        fprintf('[WARNING] some imaginary eigenvalues...\n');
    end
    if norm(imag(V))>0
        fprintf('[WARNING] some imaginary eigenvectors...\n');
    end
    E = real(E);
    V = real(V);
    
    E = diag(E);
    
    [vals, ids] = sort(abs(E), 'descend');
    V = V(:, ids);
    E = E(ids);
    
    writeMatrixDense(full(V), [prefix '.eigenvectors.bin']);
    writeVector(E, [prefix '.eigenvalues.bin']);
    cTime = toc;
    fprintf('Spectral Analysis Time=%f\n', cTime);
    fid2 = fopen([prefix '.time.bin'], 'wb');
    fwrite(fid2, double(cTime), 'double');
    fclose(fid2);
    %exit
catch exception
    exception
    exception.stack
   % exit
end
end