#include <vector>
#include <map>
#include <assert.h>
#include <iostream>
#include <fstream>

#include "VKString.h"
#include "VKStringList.h"

#ifndef __PARAM_PARESER_H
#define __PARAM_PARESER_H

class ParamParser
{
	public:
		ParamParser(const VKString & inFilename, const char ** argv = NULL, int argc = 0);
		ParamParser(){}
		void PrintParams();
		void WriteParams(const VKString & outFile);

		VKStringList & GetStrValues(const VKString & module, 
										  const VKString & valName);
	
		VKString GetStrValue(const VKString & module, 
							 const VKString &valName);
		
		double GetDoubleValue(const VKString & module, 
							  const VKString & valName);
		
		int GetIntValue(const VKString & module, 
						const VKString & valName);
		
		std::vector<double> GetDoubleValues(const VKString & module, 
											const VKString & valName);
		
		std::vector<int> GetIntValues(const VKString & module, 
									  const VKString & valName);
	
		VKStringList & GetStrValues(const VKString & module, 
									const VKString &  valName, bool & valid);
	
		VKString GetStrValue(const VKString & module, 
							 const VKString &valName, bool & valid);
	
		double GetDoubleValue(const VKString & module, 
							  const VKString & valName, bool & valid);
	
		int GetIntValue(const VKString & module, 
						const VKString & valName, bool & valid);
	
		std::vector<double> GetDoubleValues(const VKString & module, 
											const VKString & valName, bool & valid);
	
		std::vector<int> GetIntValues(const VKString & module, 
									  const VKString & valName, bool & valid);
	
		int NModules() const;
		const VKString & ModuleName(int moduleID) const;
		void SetParam(const VKString & moduleName, const VKString & paramName,
					  const VKStringList & vals = VKStringList());
	
	private:
		std::map<VKString, int> m_ParamModulesIDs;
		std::vector<std::map<VKString, VKStringList> > m_ModulesContent;
		std::vector<VKStringList> m_ModuleAndParamOrder;

	
		void AssertParamValid(const VKString & module, const VKString & paramName,
							  const char * datatype, const char * find_parse);	
		bool m_Valid;
		VKStringList m_EmptyList;
};

#endif

