/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __CorrValue_H
#define __CorrValue_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>
#include "GeomShape.h"
class ShapeCorrs;

class CorrValue
{
	public:
		CorrValue(ShapeCorrs * shapeCorrs,
				  const VKString & corrValName);
		virtual ~CorrValue();
		
		virtual const VKString & CorrValueName() const;
		virtual double IntegratedValue() = 0;
		virtual double Value(const ShapePoint & pFrom, 
							 const ShapePoint & pTo) = 0;
			
		virtual void WriteCorrVals(const VKString & filename);
		virtual void ReadCorrVals(const VKString & filename);
		
		virtual void WriteCorrVals(FILE * file);
		virtual void ReadCorrVals(FILE * file);

	
	protected:
		ShapeCorrs * m_pShapeCorrs;
		VKString m_sCorrValName;
	
};

#endif

