/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __CorrsDistProjection_H
#define __CorrsDistProjection_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>
#include "gaps.h"

#include "GeomShape.h"
#include "ShapePoint.h"
#include "CorrsSinglePair.h"

/** 
 * CorrsDistProjection used in CorrsModelGeoms
 */
class CorrsDistProjection : public CorrsSinglePair
{
	public:
		enum InterpolationType
		{
			INTERP_NEAREST_NEIGHBOR,
			INTERP_GAUSSIAN
		};
	
		CorrsDistProjection(const VKString & corrsName,
							GeomShape * shapeFrom, 
							GeomShape * shapeTo, 
							const VKString & distMetricName,
							InterpolationType interpType = INTERP_NEAREST_NEIGHBOR);
	
	protected:
		InterpolationType m_InterpType;
};

#endif

