/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#include "Model3D.h"
#include "CorrsModelGeoms.h"

CorrsModelGeoms::CorrsModelGeoms(const VKString & corrsName, 
								 Model3D * model,
								 CorrsDistProjection::InterpolationType interp)
: ShapeCorrs(corrsName)
{
	m_pModel = model;
	m_Interp = interp;
}

CorrsModelGeoms::~CorrsModelGeoms()
{
	
}

void CorrsModelGeoms::Domain(std::vector<GeomShape *> & domainShapes)
{
	for (int i=0; i<m_pModel->NGeometries(); i++)
		domainShapes.push_back(m_pModel->GetGeomShape(i));
}

void CorrsModelGeoms::Range(std::vector<GeomShape *> & rangeShapes)
{
	// domain == range
	Domain(rangeShapes);
}

int CorrsModelGeoms::GetCorrs(const ShapePoint & pnt,
							  std::vector<ShapePoint> & corrs,
							  const VKString & corrValName,
							  std::vector<double> *corrVals)
{
	// doesn't seem useful. 
	assert(false);
	return -1;
}

int CorrsModelGeoms::PairwiseCorrs(const ShapePoint & pnt,
									GeomShape * toShape,
									std::vector<ShapePoint> & corrs, 
									const VKString & corrValName,
									std::vector<double> * corrValue)
{
	// only if using a more sophisticated interpolation
	assert(false);
	return -1;
}

ShapePoint CorrsModelGeoms::BestCorr(const ShapePoint & pnt,
									 GeomShape * toShape,
									 const VKString & corrValName,
									 double * corrValue)
{
	// pnt geometry
	// vals: weights	
	assert(false);
	return ShapePoint();
}

//void CorrsModelGeoms::WriteShapeCorrs(FILE * file)
//{
//	
//}
//
//void CorrsModelGeoms::ReadShapeCorrs(FILE * file)
//{
//	
//}


