/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __DistEuclidean_H
#define __DistEuclidean_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>

#include "GeomShape.h"
#include "ShapeDistance.h"

class DistEuclidean : public ShapeDistance
{
	public:
		DistEuclidean(GeomShape * shape, const VKString & metricName, double norm = -1);
		virtual ~DistEuclidean();
		virtual DistEuclidean * SafeCastToEuclidean();

		virtual double NormalizedDistance(double distance) const;
		virtual double NormalizedDistance(const ShapePoint & p1, 
										  const ShapePoint & p2) const;
		virtual void NearestNeighborhood(const ShapePoint & p,  double distanceThreshold,
										 std::vector<ShapePoint> * neighborhood, std::vector<double> * normDists = NULL) const;
		virtual ShapePoint NearestNeighbor(const ShapePoint & p, double* normDists = NULL) const;

	protected:
};

#endif

