/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __ShapeDescriptor_H
#define __ShapeDescriptor_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>

#include "GeomShape.h"

class ShapeDescriptor : public GeomShape
{
	public:	
		ShapeDescriptor(const VKString & geomName = "none",
						Model3D * model = NULL);
		virtual void SetModel(Model3D * model);

		virtual void WriteGeometryFile(const VKString & geomFile) const;
		virtual void ReadGeometryFile(const VKString & geomFile);
		
		virtual double Similarity(ShapeDescriptor * otherDescriptor);

	protected:
		int m_iNVals;
		double * m_Vals;
};

#endif

