/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __ShapeGrid_H
#define __ShapeGrid_H

#include <vector>
#include <map>
#include <iostream>
#include <assert.h>

#include "VKString.h"
#include "ShapePoint.h"
#include "ShapeMesh.h"
#include "gaps.h"


class ShapeGrid
{
	public:
		ShapeGrid(ShapeMesh * mesh, double rotation, double cellsize=0.02);
		virtual double PointDepth(const R3Point & point, bool interpolate = true) const;
	
//	protected:
		virtual void InitGrid(double step, int maxcells, double rotation);
		
		ShapeMesh * m_pMesh;
		R3Grid * m_pObjectDepthGrid;
		R3Grid * m_pObjectVoronoiGrid;
		R3Grid * m_pDist2SurfaceGrid;
		ShapePointCloud * m_pInsidePoints;
		R3Affine m_XForm;
		
		// params
		double m_fGridCellSize;
		int m_iNumDilations;
		
		int m_iGridFlags;
};


#endif

