#include "PosePrior.h"

#ifndef __POSE_PRIOR_GAUSS_H
#define __POSE_PRIOR_GAUSS_H

// some forward declarations for gausssian
class PosePointGauss;
class MultiGauss;


/**
 * angle gaussians
 */
class PosePriorGauss : public PriorAngles
{
public:
	PosePriorGauss();
	virtual void SetParams(double maxPenalty, double variance=-1);
//	virtual void Energy(const InteractorPose * pose, EnergyInfo & energy);
	virtual void Train(const std::vector<const InteractorPose *> & pose);
	
	virtual void WritePrior(const VKString & filename) const;
	virtual void ReadPrior(FILE * file);
	virtual PosePriorType PriorType() const;
	
	virtual int NTerms() const;
	virtual double EnergyTerm(const InteractorPose * pose, int termID, EnergyInfo & info) const;
	void NonZeroJacobians(std::vector<int> & termIDs, std::vector<int> & paramIDs) const;
	
	virtual void GetAngleDistrID(int termID, int & getLinkID, int & getDimID) const;
	
	//protected:
	std::vector<PosePointGauss*> m_AngleDistributions;
	std::vector<int> m_TermID2DistrID;
	std::vector<int> m_TermID2DimID;
	
	std::vector<int> m_Assigned;
	int m_iNTotal;
	
	
	// params:
	double m_fMaxPenalty;
};




#endif


