#!/usr/bin/python

##########
#
# train classifier
#
##########
import os, string, decimal, glob, re, subprocess, shlex, sys, datetime, pickle
import numpy as np
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])))
import fas, exp
# NOTE: if you get an error here, you need to install scikit-learn
# More info: http://www.scipy.org/install.html
# I used the following on mac: sudo port install py27-numpy py27-scipy 
from sklearn.ensemble import RandomForestRegressor
from sklearn.metrics import mean_squared_error

def ReadArff(filename):
	isData = False;
	datasize=-1;
	data = [];
	with open(filename, "r") as f:
		for lnStr in f:
			if isData:
				lnSplit = lnStr.strip().split(",");
				if len(lnSplit)==1:
					lnSplit = lnStr.strip().split(" ");
				assert(datasize==-1 or datasize==len(lnSplit));
				dataline = [];
				for x in lnSplit:
					xflt = 0;
					if x!="?":
						xflt = float(x);
					dataline.append(xflt);
				data.append(dataline);
			elif lnStr.strip()=="@data" or lnStr.strip()=="@DATA": # header
				isData = True;
	return data;

def Arff2Train(data):
	X = [];
	y = [];
	for row in data:
		X.append(row[:-1]);
		y.append(row[-1]);
	return X, y;

trainData = "none";
testData = "none";

if len(sys.argv)<2:
	print("Usage: "+sys.argv[0]+" [options]");
	print("Options:");
	print("   -train train.arff out.classifier outinfo.txt");
	print("   -test in.classifier intest.arff out.predictions ");
	exit();
else:
	i=1;
	while i<len(sys.argv):
		if (sys.argv[i]=="-train"):
			trainData = sys.argv[i+1];
			outclassifier = sys.argv[i+2];
			outinfo = sys.argv[i+3];
			i+=3;
		elif (sys.argv[i]=="-test"):
			inClassifier = sys.argv[i+1];
			testData = sys.argv[i+2];
			outPredictions = sys.argv[i+3];
			i+=3;
		else:
			print("[ERROR] Unknown argument (randomforest.py): "+sys.argv[i]);
			assert(False);
		i+=1;

if trainData!="none":
	X, y = Arff2Train(ReadArff(trainData));
	#reg = RandomForestRegressor(n_estimators=30, max_depth=5);
	reg = RandomForestRegressor(n_estimators=30);
	reg.fit(X, y);
	with open(outclassifier, "w") as f:
		pickle.dump(reg, f);

if testData!="none":
	with open(inClassifier, "r") as f:
		reg = pickle.loads(f.read());
	X, y = Arff2Train(ReadArff(testData));
	P = reg.predict(X);
	print("Predicting")
#	print(X);
#	print(P);
	with open(outPredictions, "w") as f:
		f.write("=== Predictions on test data ===\n");
		f.write(" inst#     actual  predicted      error\n");
		id = 1;
		for prediction in P: # fake weka
			f.write(str(id)+" ? "+str(prediction)+" ?\n");
			id = id + 1;


