#!/usr/bin/python

##########
#
#  Predict pose
#
##########
import os, string, glob, sys
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])))
import fas, exp

modelsDir = "none";
pntsDir = "none";
densePntsDir = "none";
outDir = "none";
testFile = "none";
forceRecompute = False;			# re-do results
predictDir = "none";
readRegionStats = "none";
clusterWorkspace = "./TempDir";
disallowParallel = False;

if len(sys.argv)<2:
	print("Usage: "+sys.argv[0]+" [options]");
	print("Options:");
	print("   -modelsDir dir");
	print("   -pntsDir dir");
	print("   -densePntsDir dir");
	print("   -predictDir dir ");
	print("   -predictedPoseDir dir ");
	print("   -posePriorFile file ");
	print("   -outDir dir ");
	print("   -forceRecompute ");
	print("   -testFile file ");
	print("   -readRegionNames regionNamesFile ");
	print("   -readSkeleton skeletonFile ");
	print("   -clusterWorkspace directory ");
	print("   -origrotate filename");
	print("   -disallowParallel");
	exit();
else:
	i = 1;
	while i<len(sys.argv):
		if (sys.argv[i]=="-modelsDir"):
			i=i+1;
			modelsDir = sys.argv[i];
		elif (sys.argv[i]=="-pntsDir"):
			i=i+1;
			pntsDir = sys.argv[i];
		elif (sys.argv[i]=="-origrotate"):
			i=i+1;
			origrotate = sys.argv[i];
		elif (sys.argv[i]=="-densePntsDir"):
			i=i+1;
			densePntsDir = sys.argv[i];
		elif (sys.argv[i]=="-predictDir"):
			i=i+1;
			predictDir = sys.argv[i];
		elif (sys.argv[i]=="-predictedPoseDir"):
			i=i+1;
			predictedPoseDir = sys.argv[i];
		elif (sys.argv[i]=="-posePriorFile"):
			i=i+1;
			posePriorFile = sys.argv[i];
		elif (sys.argv[i]=="-outDir"):
			i=i+1;
			outDir = sys.argv[i];
		elif (sys.argv[i]=="-forceRecompute"):
			forceRecompute = True;
		elif (sys.argv[i]=="-testFile"):
			i=i+1;
			testFile = sys.argv[i];
		elif (sys.argv[i]=="-clusterWorkspace"):
			i=i+1;
			clusterWorkspace = sys.argv[i];
		elif (sys.argv[i]=="-disallowParallel"):
			disallowParallel = True;
		elif (sys.argv[i]=="-readRegionNames"):
			i=i+1;
			readRegionNames = sys.argv[i];
		elif (sys.argv[i]=="-readRegionStats"):
			i=i+1;
			readRegionStats = sys.argv[i];
		elif (sys.argv[i]=="-readSkeleton"):
			i=i+1;
			readSkeleton = sys.argv[i];
		else:
			print("[ERROR] Unknown argument "+sys.argv[i]+" in renderPoses.py ");
			exit();
		i=i+1;


symmInv = "";

# Prepare files
mListTest = fas.ReadModelNames(testFile)

## Prepare region lists
rList = fas.ReadRegionNames(readRegionNames);
jobIDs = [];
removeFiles = [];

##
# Render poses
counter = 0;
#mListTest = ["chair0002"]
for mName in mListTest:
	predictedPoseFile = predictedPoseDir+"/"+mName;
	finalPoses = outDir+"/"+mName+"/";
	if (os.path.isdir(predictedPoseFile) and (not os.path.isdir(finalPoses) or forceRecompute)):
		offFile = modelsDir+"/"+mName+".off";
		pntsFile = pntsDir+"/"+mName+".pts";
		densePntsFile = densePntsDir+"/"+mName+".pts";
		predictionFile = predictDir+"/"+mName+".arff";
		cmd = exp.exedir+"FnAlign -r object "+offFile+" -r actor_pnts -r bindings "+predictedPoseFile+" ";
		cmd += "-r object_points "+pntsFile+" -r object_predictions "+predictionFile+" ";
		if densePntsFile!="none":
			cmd += "-r object_densepoints "+densePntsFile+" ";
		cmd += "-r regionStats "+readRegionStats+" ";
		cmd += "-r regionNames "+readRegionNames+" -r skeleton "+readSkeleton+" ";
		cmd += "-r actor_poseprior "+posePriorFile+" ";
		cmd += "-w img_poses "+finalPoses+"/ -w img_candidates "+finalPoses+"/candidates ";
		cmd += "-origrotate "+origrotate+"/"+mName+".xform ";
		#cmd += "-vis ";
		scriptFile = clusterWorkspace+"/"+mName;
		if not disallowParallel:
			jobIDs += fas.ScheduleJob(cmd, "rpos_"+mName, scriptFile);
			removeFiles += fas.TmpFilesNames(scriptFile);
		else:
			os.system(cmd+" ");

fas.WaitForJobsInArray(jobIDs);
#for file in removeFiles:
#	if os.path.isfile(file):
#		os.remove(file);
