#!/usr/bin/python

##########
#
#  Render classified regions (smooth predictions)
#
##########
import os, string, glob, sys
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])))
import fas, exp

modelsDir = "none";
pntsDir = "none";
outDir = "none";
testFile = "none";
featureNameFile = "none";
forceRecompute = False;			# re-train classifier even if exists
predictDir = "none";
vis = "";
clusterWorkspace = "./TempDir";
disallowParallel = False;

if len(sys.argv)<2:
	print("Usage: "+sys.argv[0]+" [options]");
	print("Options:");
	print("   -modelsDir dir");
	print("   -pntsDir dir");
	print("   -predictDir dir ");
	print("   -outDir dir ");
	print("   -forceRecompute ");
	print("   -testFile file ");
	print("   -clusterWorkspace directory ");
	print("   -disallowParallel");
	exit();
else:
	i = 1;
	while i<len(sys.argv):
		if (sys.argv[i]=="-modelsDir"):
			i=i+1;
			modelsDir = sys.argv[i];
		elif (sys.argv[i]=="-pntsDir"):
			i=i+1;
			pntsDir = sys.argv[i];
		elif (sys.argv[i]=="-predictDir"):
			i=i+1;
			predictDir = sys.argv[i];
		elif (sys.argv[i]=="-outDir"):
			i=i+1;
			outDir = sys.argv[i];
		elif (sys.argv[i]=="-forceRecompute"):
			forceRecompute = True;
		elif (sys.argv[i]=="-vis"):
			vis = "-vis ";
		elif (sys.argv[i]=="-testFile"):
			i=i+1;
			testFile = sys.argv[i];
		elif (sys.argv[i]=="-clusterWorkspace"):
			i=i+1;
			clusterWorkspace = sys.argv[i];
		elif (sys.argv[i]=="-disallowParallel"):
			disallowParallel = True;
		elif (sys.argv[i]=="-readRegionNames"):
			i=i+1;
			readRegionNames = sys.argv[i];
		else:
			print("[ERROR] Unknown argument "+sys.argv[i]+" in renderRegions.py ");
			exit();
		i=i+1;


# Prepare files
mListTest = fas.ReadModelNames(testFile);


# Prepare files
rList = fas.ReadRegionNames(readRegionNames);
jobIDs = [];
removeFiles = [];

##
# Classify regions
counter = 0;
for mName in mListTest:
	counter = counter + 1;
	offFile = modelsDir+"/"+mName+".off";
	pntsFile = pntsDir+"/"+mName+".pts";
	predictionFile = predictDir+"/"+mName+".arff";
	
	screenshotsDir = outDir+"/"+mName+"/";
	if not os.path.isdir(screenshotsDir) or forceRecompute:
		cmd = exp.exedir+"FnRegionClassifier  ";
		cmd += "-ro "+mName+" mesh "+offFile+" ";
		cmd += "-ro "+mName+" featpnts "+pntsFile+" ";
		cmd += "-r gtnames "+readRegionNames+" ";
		cmd += "-ro "+mName+" prediction "+predictionFile+" ";
		cmd += "-wo "+mName+" img_predict "+screenshotsDir+" ";
		#cmd += "-wo "+mName+" img_combined "+screenshotsDir+"/combined_ ";

		if not disallowParallel:
			scriptFile = clusterWorkspace+"/"+mName;
			jobIDs += fas.ScheduleJob(cmd, "rereg_"+mName, scriptFile)
			removeFiles += fas.TmpFilesNames(scriptFile);
		else:
			os.system(cmd+" ")
fas.WaitForJobsInArray(jobIDs);
#for file in removeFiles:
#	if os.path.isfile(file):
#		os.remove(file);

