#!/usr/bin/python

##########
#
#  Train pose priors
#
##########
import os, string, glob, sys
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])))
import fas, exp

gtDir = "none";
trainFile = "none";
outFile = "none";
outTiming = "none";
priorType = "none";
comDir = "none";
forceRecompute = False;			# re-train classifier even if exists
clusterWorkspace = "./TempDir";
params = "";
ignorePalmsAndToes = False;
vis = False;
randseed = "0";
disallowParallel = False;

if len(sys.argv)<2:
	print("Usage: "+sys.argv[0]+" [options]");
	print("Options:");
	print("   -gtDir inDir");
	print("   -comDir inDir");
	print("   -trainFile inFile");
	print("   -outFile outFile ");
	print("   -outTiming outFile ");
	print("   -forceRecompute ");
	print("   -priorType [gauss1,gaussmulti]");
	print("   -readRegionNames region ");
	print("   -readSkeleton skeleton ");
	print("   -ignorePalmsAndToes ");
	print("   -vis ");
	print("   -param N paramName paramlist x N ");
	print("   -clusterWorkspace directory ");
	print("   -randseed seed - (seed can be -1) ");
	print("   -disallowParallel");
	exit();
else:
	i = 1;
	while i<len(sys.argv):
		if (sys.argv[i]=="-gtDir"):
			i=i+1;
			gtDir = sys.argv[i];
		elif (sys.argv[i]=="-comDir"):
			i=i+1;
			comDir = sys.argv[i];
		elif (sys.argv[i]=="-trainFile"):
			i=i+1;
			trainFile = sys.argv[i];
		elif (sys.argv[i]=="-outFile"):
			i=i+1;
			outFile = sys.argv[i];
		elif (sys.argv[i]=="-outTiming"):
			i=i+1;
			outTiming = sys.argv[i];
		elif (sys.argv[i]=="-forceRecompute"):
			forceRecompute = True;
		elif (sys.argv[i]=="-readRegionNames"):
			i=i+1;
			readRegionNames = sys.argv[i];
		elif (sys.argv[i]=="-ignorePalmsAndToes"):
			ignorePalmsAndToes = True;
		elif (sys.argv[i]=="-vis"):
			vis = True;
		elif (sys.argv[i]=="-readSkeleton"):
			i=i+1;
			readSkeleton = sys.argv[i];
		elif (sys.argv[i]=="-clusterWorkspace"):
			i=i+1;
			clusterWorkspace = sys.argv[i];
		elif (sys.argv[i]=="-disallowParallel"):
			disallowParallel = True;
		elif (sys.argv[i]=="-readRegionStats"):
			i = i + 1;
			readRegionStats = sys.argv[i];
		elif (sys.argv[i]=="-param"):
			nparams = int(sys.argv[i+1]);
			params += "-"+sys.argv[i+2]+" ";
			for j in range(0,nparams):
				params += sys.argv[i+3+j]+" ";
			i += 2+nparams;
		elif (sys.argv[i]=="-param2"):
			params += "-param "+sys.argv[i+1]+" "+sys.argv[i+2]+" ";
			i += 2;
		elif (sys.argv[i]=="-randseed"):
			i=i+1;
			randseed = sys.argv[i];
		else:
			print("[ERROR] Unknown argument "+sys.argv[i]+" in trainPosepriors.py ");
			exit();
		i=i+1;


# Prepare files
jobIDs = [];
removeFiles = [];

######
## Train pose priors
if not os.path.isfile(outFile) or forceRecompute:
	gtFiles = [];
	comFiles = [];
	if gtDir=="cornell":
		people = [];
		people += ["data1", "data2", "data3", "data4"];
		people += ["Subject1_annotations", "Subject3_annotations", "Subject4_annotations", "Subject5_annotations"];
		for person in people:
			gtFiles += glob.glob(data + person+"/*.gt");
		ignorePalmsAndToes = True;
	else:
		mList = fas.ReadModelNames(trainFile);
		for mName in mList:
			gtFiles += [gtDir+"/"+mName+".gt"];
			#comFiles += [comDir+"/"+mName+"_symmplanes.txt"];
			comFiles += [comDir+"/"+mName+"_symmplanes.txt"];
		ignorePalmsAndToes = True;

	gtList = "";
	for gtFile in gtFiles:
		gtList += "-t "+gtFile+" ";
	for comFile in comFiles:
		gtList += "-comFile "+comFile+" ";
	cmd = exp.exedir+"FnTrainPosePrior "+outFile+" -skeleton "+readSkeleton+" "+readRegionNames+" ";
	cmd += gtList+" -writeTiming "+outTiming+" "+params+" -randseed "+randseed+" ";

#	cmd += "-readRegionStats "+readRegionStats+" ";
	if ignorePalmsAndToes:
		cmd += "-ignorePalmsAndToes "
	if vis or exp.DEBUG_VIS:
		cmd += "-vis ";

	if not disallowParallel:
		scriptFile = clusterWorkspace+"/trainPose";
		jobIDs += fas.ScheduleJob(cmd, "trainPose", scriptFile)
		removeFiles += fas.TmpFilesNames(scriptFile);
	else:
		os.system(cmd);

	fas.WaitForJobsInArray(jobIDs);
#	for file in removeFiles:
#		if os.path.isfile(file):
#			os.remove(file);

