#!/usr/bin/python

##########
#
# Predict poses using a predictor created by test
#
##########
import os, string, decimal, glob, re, subprocess, shlex, sys, datetime, random
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/scriptlibs"))
import fas, exp, figs

evaluate = False;

if len(sys.argv)<4:
	print("Usage: "+sys.argv[0]+" dataset expname modellist.txt [optional] ");
	print("       $dataset$ models used for testing, subset of:  ../data/1_input/$dataset$/off");
	print("       $expname$ use the predictor stored in 3_trained/{classifier,poseprior}/$expname$/*");
	print("       modellist.txt  a text file with test model names from $dataset$/off directories");
	print("Optional:");
	print("       -evaluate -- only if ../data/1_input/$dataset$/gt contains ground truth data for each test model ");
	print("Example 1 (with evaluation): "+sys.argv[0]+" small witheval_small examples/test_small.txt -evaluate ");
	print("Example 2 (w/o evaluation): "+sys.argv[0]+" small_nogt noeval_small examples/test_small.txt ");
	exit();
else:
	loo = [sys.argv[1]];
	expname = sys.argv[2];
	testList = sys.argv[3];
	i = 4;
	while i<len(sys.argv):
		if (sys.argv[i]=="-evaluate"):
			evaluate = True;
		else:
			print("[ERROR] Cannot understand command: "+sys.argv[i]+" in test.py");
			assert(False);
		i=i+1;

expArray = [];
# basicExpType expname   dataset   traindata   testdata   priorname   claname


#addflags = "-force train -force predict -force render_predict -force eval_predict -force prior -force poses -force render_poses -force eval_poses ";
addflags = " ";

# Run leave-one-out experiments
for dset in loo:
	e = exp.ExpConfigs();
	e.m_BasicType = "test";
	e.m_ExpName = expname;
	e.m_Dataset = dset;
	#e.m_ClusterWorkspace = "./TempDir/"+e.m_BasicType+fracStr+"_"+pfix+"_"+dset+"/";
	e.m_ClusterWorkspace = "./TempDir/"+expname+"/";
	e.m_Flags = "-pipeline render -pipeline points -pipeline features ";
	expArray.append(e);
	
	expInfoDir = exp.ExpInfo(expname);
	if not os.path.isdir(expInfoDir):
		os.makedirs(expInfoDir);
	featNamesFile = expInfoDir+"/features.txt";
	paramFileCopy = expInfoDir+"/params.txt";
	params = exp.ReadParams(exp.ExpConfigs().m_ParamFile);

	params.WriteFeatureNames(featNamesFile);
	params.WriteParams(paramFileCopy);
	
	# train / test for single model
	e = exp.ExpConfigs();
	e.m_ParamFile = paramFileCopy;
	e.m_BasicType = "test";
	e.m_ExpName = expname;
	e.m_Dataset = dset;
	e.m_TestFile = testList;
	# region classifier
	e.m_ClaDataset = dset;
	e.m_ClaTrainFile = "none";
	e.m_ClaName = "/"+expname;
	e.m_ClaType = "Weka";
	
	# pose prior
	e.m_PriorDataset = dset;
	e.m_PriorTrainFile = "none";
	e.m_PriorName = "/"+expname+"/prior";
	
	# flags
	e.m_ClusterWorkspace = "./TempDir/"+expname+"/";
	e.m_WorkName = e.m_BasicType+"_test";
	e.m_Flags = "-pipeline predict -pipeline render_predict -pipeline poses -pipeline render_poses ";

	e.m_bRunInParallel = True;
	
	expArray.append(e);


# Wait for results
e = exp.ExpConfigs();
e.m_bWaitForResults = True;
expArray.append(e);

# Evaluate leave-one-out experiments
if evaluate:
	for dset in loo:
		# Copy results
		e = exp.ExpConfigs();
		e.m_BasicType = "test";
		e.m_ExpName = expname;
		e.m_Dataset = dset;
		e.m_TestFile = testList;
		
		expFilesDir = exp.ExpInfo(expname);
		if not os.path.isdir(expFilesDir):
			os.makedirs(expFilesDir);
		if not os.path.isfile(expFilesDir+"/test.txt"):
			os.system("cp "+testList +" "+expFilesDir+"/test.txt");
		
		# doesn't matter (just to avoid errors)
		e.m_ClaDataset = dset;
		e.m_ClaTrainFile = "none";
		e.m_ClaName = "/"+expname;
		e.m_ClaType = "Weka";
		e.m_PriorDataset = dset;
		e.m_PriorName = "/"+expname+"/prior";
		e.m_PriorTrainFile = "none";  # random - does not matter
		e.m_ClusterWorkspace = "./TempDir/"+expname+"/";
		e.m_WorkName = dset+"_final";
		
		# schedule
		e.m_Flags += "-pipeline eval_predict -pipeline eval_poses ";
		e.m_bRunInParallel = True;
		expArray.append(e);

# Wait for evaluations to finish
e = exp.ExpConfigs();
e.m_bWaitForResults = True;
expArray.append(e);

exp.RunExperiments(expArray, addflags);


