#!/usr/bin/python

##########
#
# Train a pose predictor. Run the script with no arguments to see the argument list.
#
##########
import os, string, decimal, glob, re, subprocess, shlex, sys, datetime, random
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/scriptlibs"))
import fas, exp, figs

if len(sys.argv)<4:
	print("Usage: "+sys.argv[0]+" dataset expname modellist.txt ");
	print("       $dataset$ uses directories: ../data/1_input/$dataset$/{off, gt}");
	print("       $expname$ trains a pose predictor stored in 3_trained/{classifier,poseprior}/$expname$/*");
	print("       modellist.txt  a text file that stores model names from $dataset$/{off,gt} directories");
	print("Example use: "+sys.argv[0]+" small exp1_small examples/train_small.txt");
	exit();
else:
	loo = [sys.argv[1]];
	expname = sys.argv[2];
	trainList = sys.argv[3];


expArray = [];
# basicExpType expname   dataset   traindata   testdata   priorname   claname

loo_forceAnlaysis = True;

#addflags = "-force train -force predict -force render_predict -force eval_predict -force prior -force poses -force render_poses -force eval_poses ";
addflags = " ";

# Run leave-one-out experiments
for dset in loo:
	# prepare data
	e = exp.ExpConfigs();
	e.m_BasicType = "train";
	e.m_ExpName = expname;
	e.m_Dataset = dset;
	e.m_ClusterWorkspace = "./TempDir/"+expname+"/";
	e.m_Flags = "-pipeline render -pipeline points -pipeline features ";
	expArray.append(e);
	
	expInfoDir = exp.ExpInfo(expname);
	if not os.path.isdir(expInfoDir):
		os.makedirs(expInfoDir);
	featNamesFile = expInfoDir+"/features.txt";
	paramFileCopy = expInfoDir+"/params.txt";
	params = exp.ReadParams(exp.ExpConfigs().m_ParamFile);

	params.WriteFeatureNames(featNamesFile);
	params.WriteParams(paramFileCopy);
	
	e = exp.ExpConfigs();
	e.m_ParamFile = paramFileCopy;
	e.m_BasicType = "train";
	e.m_ExpName = expname;
	e.m_Dataset = dset;
	e.m_TestFile = "none";
	# region classifier
	e.m_ClaDataset = dset;
	e.m_ClaTrainFile = trainList;
	e.m_ClaName = "/"+expname;
	e.m_ClaType = "Weka";
	
	# pose prior
	e.m_PriorDataset = dset;
	e.m_PriorTrainFile = trainList;
	e.m_PriorName = "/"+expname+"/prior";
	
	# flags
	e.m_ClusterWorkspace = "./TempDir/"+expname+"/";
	e.m_WorkName = e.m_BasicType+"_train";
	e.m_Flags = "-pipeline train -pipeline prior ";

	e.m_bRunInParallel = True;

	expArray.append(e);


# Wait for results
e = exp.ExpConfigs();
e.m_bWaitForResults = True;
expArray.append(e);

exp.RunExperiments(expArray, addflags);


