#!/usr/bin/python

##########
#
# Visualize a result of an experiment 
#
##########
import os, string, decimal, glob, re, subprocess, shlex, sys, datetime, random
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/scriptlibs"))
import fas, exp, figs

leaveOneOut = False;
if len(sys.argv)<4:
	print("Usage: "+sys.argv[0]+" dataset expname modelname [optional]");
	print("       $dataset$ input model should be in "+exp.Models("$dataset$")+"/$modelname$.off ");
	print("       $expname$ predicted poses should be in:\n             "+exp.Poses("$expname$")+"/$modelname$/bindings.bin");
	print("       $modelname$ do not include file extension (see paths above)");
#	print("Optional:");
#	print("       -leave-one-out   - set if results were produced by runLeaveOneOut.py script");
#	print("            NOTE: Look for pose prior in 3_trained/poseprior/$expname$/$modelname$.bin");
#	print("            The script should also work without this flag too");
	print("Example use: "+sys.argv[0]+" small loo_test_small 009");
	exit();
else:
	dataset = sys.argv[1];
	expname = sys.argv[2];
	mName = sys.argv[3];
	i = 4;
	while i<len(sys.argv):
		if (sys.argv[i]=="-leave-one-out"):
			leaveOneOut = True;
		else:
			print("[ERROR] Cannot understand command: "+sys.argv[i]+" in experiment.py");
			assert(False);
		i=i+1;

offFile = exp.Models(dataset)+"/"+mName+".off "
pntsFile = exp.Points(dataset, "even", "1000")+"/"+mName+".pts";
predictedPoseFile = exp.Poses(expname)+"/"+mName+"/";
predictionFile = exp.Prediction(expname)+"/"+mName+".arff"
posePriorFile = exp.PosePriorFile(expname+"/poseprior");
if leaveOneOut or not os.path.isfile(posePriorFile):
	if not leaveOneOut:
		print("[WARNING] Could not find pose prior: "+posePriorFile);
	posePriorFile = exp.PosePriorFile(expname+"/"+mName);
	if not os.path.isfile(posePriorFile):
		print("[ERROR] Could not find pose prior: "+posePriorFile);
		exit();

claDir = exp.Classifier(expname);
if leaveOneOut or not os.path.isfile(claDir+"/regionstats.txt"):
	if not leaveOneOut:
		print("[WARNING] Could not find classifier data in "+claDir);
	claDir = exp.Classifier(expname+"/"+mName);
	if not os.path.isfile(claDir+"/regionstats.txt"):
		print("[ERROR] Could not find classifier data: "+claDir);
		exit();

densePntsFile = exp.Points(dataset, "random", "100000")+"/"+mName+".pts";

cmd = exp.exedir+"FnAlign -r object "+offFile+" -r actor_pnts -r bindings "+predictedPoseFile+" ";
cmd += "-r object_points "+pntsFile+" -r object_densepoints "+densePntsFile+" -r object_predictions "+predictionFile+" ";
cmd += "-r regionStats "+claDir+"/regionstats.txt"+" ";
cmd += "-r regionNames "+exp.HumanBodyParts()+" -r skeleton "+exp.HumanSkeleton()+" ";
cmd += "-r actor_poseprior "+posePriorFile+" -vis ";

# optional: write ascii file if it doesn't exist
if not os.path.isfile(predictedPoseFile+"/poses.txt"):
	cmd += "-w gt "+predictedPoseFile+"/poses.txt ";

os.system(cmd);


